<template>
  <div v-if="user">
    <UserTop :data="user" />
    <div class="user-navigation">
      <ul>
        <li class="item">
          <nuxt-link :to="`/profile`">Portfolio</nuxt-link>
        </li>
        <li class="item">
          <nuxt-link :to="`/profile/store/events`"> Events </nuxt-link>
        </li>
        <li class="item">
          <nuxt-link :to="`/profile/store/events`">Wallpapers</nuxt-link>
        </li>
        <li class="item">
          <nuxt-link :to="`/profile/store/products`">Products</nuxt-link>
        </li>
        <li class="item">
          <nuxt-link :to="`/profile/store/nft`">NFT</nuxt-link>
        </li>
        <li class="item">
          <nuxt-link :to="`/profile/store/orders`">Orders</nuxt-link>
        </li>
      </ul>
    </div>
    <el-upload where="portfolio" multiple />
    <Feed :counter="false" :data="media" :moderate="false" />
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  useContext,
  ref,
  computed
} from '@nuxtjs/composition-api'
import { MediaFileFragment } from '~/sdk/types'
import { useMediaSubscription, useDeleteMediaMutation } from '~/sdk/hooks'

import UserTop from '@/components/profile/UserTop.vue'
import Feed from '@/components/ui/Feed.vue'
import elUpload from '@/components/element/Upload.vue'
export default defineComponent({
  name: 'PersonalIndexPage',
  components: { UserTop, elUpload, Feed },
  setup(_, { root }) {
    const { app } = useContext()
    const user = computed(() => root.$accessor.auth.user)
    const modals = ref({
      delete: false
    })
    const media = ref<MediaFileFragment[]>([])
    const { onResult, loading } = useMediaSubscription({
      where: {
        album_id: { _is_null: true },
        event_id: { _is_null: true },
        user_id: { _eq: root.$accessor.auth.userId }
      },
      limit: 10000,
      offset: 0
    })
    onResult(result => {
      if (result?.data?.media_files) {
        media.value = result.data.media_files
      }
    })

    const MediaEditCheckBox = ref(false)
    const MediaEditList = ref([])
    const onClickMediaEdit = () => {
      if (MediaEditCheckBox.value !== false) {
        MediaEditCheckBox.value = false
        MediaEditList.value = []
      } else {
        MediaEditCheckBox.value = true
      }
    }

    // delete images

    const { mutate: deleteMutate } = useDeleteMediaMutation({})
    const deleteMediaItems = async (items: any) => {
      try {
        await items.forEach((i: any) => {
          deleteMutate({ id: i })
        })
      } catch (err) {
        root.$message.error('Что-то пошло не так...')
      } finally {
        root.$message.success('Изображения успешно удалены')
      }
      modals.value.delete = false
      MediaEditList.value = []
      MediaEditCheckBox.value = false
    }

    return {
      user,
      media,
      loading,
      modals,

      onClickMediaEdit,
      MediaEditList,
      MediaEditCheckBox,
      deleteMediaItems
    }
  }
})
</script>

<style lang="scss" scoped>
.user-navigation {
  margin-top: 35px;
  margin-bottom: 40px;
  text-align: center;
  ul {
    margin: 0px;
    padding: 0px;
    list-style: none;
    display: inline-flex;
    overflow-x: auto;
    overflow-y: hidden;
    li {
      padding: 0 15px;
      a {
        letter-spacing: -1px;
        color: #8591ad;
        font-size: 26px;
        line-height: 26px;
        font-weight: bold;
        &.is-active {
          color: #fff;
        }
      }
    }
  }
}
</style>
